FROM azul/zulu-openjdk-alpine:11 as packager
EXPOSE 8080
RUN { \
        java --version ; \
        echo "jlink version:" && \
        jlink --version ; \
    }

ENV JAVA_MINIMAL=/opt/jre

# build modules distribution
RUN jlink \
    --verbose \
    --add-modules \
        java.base,java.sql,java.naming,java.desktop,java.management,java.security.jgss,java.instrument \
        # java.naming - javax/naming/NamingException
        # java.desktop - java/beans/PropertyEditorSupport
        # java.management - javax/management/MBeanServer
        # java.security.jgss - org/ietf/jgss/GSSException
        # java.instrument - java/lang/instrument/IllegalClassFormatException
    --compress 2 \
    --strip-debug \
    --no-header-files \
    --no-man-pages \
    --output "$JAVA_MINIMAL"

# Second stage, add only our minimal "JRE" distr and our app
FROM alpine

ENV JAVA_MINIMAL=/opt/jre
ENV PATH="$PATH:$JAVA_MINIMAL/bin"

COPY --from=packager "$JAVA_MINIMAL" "$JAVA_MINIMAL"
COPY "build/libs/dropbox-tags-app-0.1.0.jar" "/dropbox-tags-app.jar"
ENTRYPOINT ["java","-Djava.security.egd=file:/dev/./urandom","-jar","dropbox-tags-app.jar"]


#FROM  dekstroza/openjdk9-alpine
#EXPOSE 8080
#ADD /build/libs/dropbox-tags-app-0.1.0.jar dropbox-tags-app.jar
#ENTRYPOINT ["java", "-jar", "dropbox-tags-app.jar"]

## A JDK 9 with Alpine Linux
#FROM alpine:3.6
## Add the musl-based JDK 9 distribution
#RUN mkdir /opt
## Download from http://jdk.java.net/9/
## ADD http://download.java.net/java/jdk9-alpine/archive/181/binaries/jdk-9-ea+181_linux-x64-musl_bin.tar.gz
#ADD jdk-9-ea+181_linux-x64-musl_bin.tar.gz /opt
## Set up env variables
#ENV JAVA_HOME=/opt/jdk-9
#ENV PATH=$PATH:$JAVA_HOME/bin
#CMD ["jshell", "-J-XX:+UnlockExperimentalVMOptions", \
#               "-J-XX:+UseCGroupMemoryLimitForHeap", \
#               "-R-XX:+UnlockExperimentalVMOptions", \
#               "-R-XX:+UseCGroupMemoryLimitForHeap"]




#FROM dekstroza/openjdk9-alpine as packager
#MAINTAINER d.mikheev90@gmail.com
#VOLUME /tmp
#EXPOSE 8080
#
#RUN /opt/jdk-9/bin/jlink \
#    --module-path /opt/jdk-9/jmods \
#    --verbose \
#    --add-modules java.base,java.logging,java.xml,jdk.unsupported \
#    --compress 2 \
#    --no-header-files \
#    --output /opt/jdk-9-minimal
#
#FROM alpine:3.6
#COPY --from=packager /opt/jdk-9-minimal /opt/jdk-9-minimal
#
#ENV JAVA_HOME=/opt/jdk-9-minimal
#ENV PATH="$PATH:$JAVA_HOME/bin"

#ENV USER_NAME d.mikheev
#ENV APP_HOME /home/$USER_NAME/app
#
#RUN useradd -ms /bin/bash $USER_NAME
#RUN mkdir $APP_HOME
#
#ARG JAR_FILE=build/libs/dropbox-tags-app-0.1.0.jar
#ADD $JAR_FILE $APP_HOME/dropbox-tags-app.jar
#RUN chown $USER_NAME $APP_HOME/dropbox-tags-app.jar
#
#USER $USER_NAME
#WORKDIR $APP_HOME
#RUN bash -c 'touch dropbox-tags-app'
#
#ENTRYPOINT ["java","-Djava.security.egd=file:/dev/./urandom","-jar","dropbox-tags-app.jar"]